commit adee9b8a80cc985c7a0ede592fe07b131303343a
Author: Marek Polacek <polacek@redhat.com>
Date:   Wed Sep 1 22:47:44 2021

    c++: Fix ICE with nullptr comparison (GCC 11) [PR101592]
    
    On trunk, PR101592 was fixed by r12-2537, but that change shouldn't be
    backported to GCC 11.  In the PR Jakub suggested this fix, so here it
    is, after the usual testing.
    
            PR c++/101592
    
    gcc/ChangeLog:
    
            * fold-const.c (make_range_step): Return NULL_TREE for NULLPTR_TYPE.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/warn/Wlogical-op-3.C: New test.
    
    Co-authored-by: Jakub Jelinek <jakub@redhat.com>

diff --git a/gcc/fold-const.c b/gcc/fold-const.c
index 39f120db38c..a1d08c74025 100644
--- a/gcc/fold-const.c
+++ b/gcc/fold-const.c
@@ -5003,7 +5003,8 @@ make_range_step (location_t loc, enum tree_code code, tree arg0, tree arg1,
 	 being not equal to zero; "out" is leaving it alone.  */
       if (low == NULL_TREE || high == NULL_TREE
 	  || ! integer_zerop (low) || ! integer_zerop (high)
-	  || TREE_CODE (arg1) != INTEGER_CST)
+	  || TREE_CODE (arg1) != INTEGER_CST
+	  || TREE_CODE (arg0_type) == NULLPTR_TYPE)
 	return NULL_TREE;
 
       switch (code)
diff --git a/gcc/testsuite/g++.dg/warn/Wlogical-op-3.C b/gcc/testsuite/g++.dg/warn/Wlogical-op-3.C
new file mode 100644
index 00000000000..4b0bc22af4d
--- /dev/null
+++ b/gcc/testsuite/g++.dg/warn/Wlogical-op-3.C
@@ -0,0 +1,12 @@
+// PR c++/101592
+// { dg-do compile { target c++11 } }
+// { dg-options "-O2 -Wlogical-op" }
+
+decltype(nullptr) foo ();
+
+bool
+bar ()
+{
+  return foo () > nullptr
+    || foo () < nullptr;
+}

